diff --git a/SHADE_Managed/src/Editor/Editor.cxx b/SHADE_Managed/src/Editor/Editor.cxx
index 735f8c2c..8d105fce 100644
--- a/SHADE_Managed/src/Editor/Editor.cxx
+++ b/SHADE_Managed/src/Editor/Editor.cxx
@@ -29,6 +29,7 @@ of DigiPen Institute of Technology is prohibited.
 #include "Editor/IconsMaterialDesign.h"
 #include "Editor/Command/SHCommandManager.h"
 #include "Editor/Command/SHCommand.hpp"
+#include "TooltipAttribute.hxx"
 
 // Using Directives
 using namespace System;
@@ -48,17 +49,17 @@ using namespace System::Collections::Generic;
 /// <param name="MANAGED_TYPE">The managed type of the object to edit.</param>
 /// <param name="NATIVE_TYPE">The native type of the object to edit.</param>
 /// <param name="FUNC">The SHEditorUI:: function to use for editing.</param>
-#define RENDER_FIELD(MANAGED_TYPE, NATIVE_TYPE, FUNC)                  \
-(field->FieldType == MANAGED_TYPE::typeid)                             \
-{                                                                      \
-    NATIVE_TYPE val = safe_cast<NATIVE_TYPE>(field->GetValue(object)); \
-    NATIVE_TYPE oldVal = val;                                          \
-    if (SHEditorUI::FUNC(Convert::ToNative(field->Name), val))         \
-    {                                                                  \
-        field->SetValue(object, val);                                  \
-        registerUndoAction(object, field, val, oldVal);                \
-    }                                                                  \
-}                                                                      \
+#define RENDER_FIELD(MANAGED_TYPE, NATIVE_TYPE, FUNC)                     \
+(field->FieldType == MANAGED_TYPE::typeid)                                \
+{                                                                         \
+    NATIVE_TYPE val = safe_cast<NATIVE_TYPE>(field->GetValue(object));    \
+    NATIVE_TYPE oldVal = val;                                             \
+    if (SHEditorUI::FUNC(Convert::ToNative(field->Name), val, &isHovered))\
+    {                                                                     \
+        field->SetValue(object, val);                                     \
+        registerUndoAction(object, field, val, oldVal);                   \
+    }                                                                     \
+}                                                                         \
 /// <summary>
 /// Macro expansion that is used in renderFieldInInspector() to check the type of a field
 /// named "field" against the specified type and if it matches, retrieves the value of
@@ -76,7 +77,7 @@ using namespace System::Collections::Generic;
 {                                                                                          \
     NATIVE_TYPE val = Convert::ToNative(safe_cast<MANAGED_TYPE>(field->GetValue(object))); \
     NATIVE_TYPE oldVal = val;                                                              \
-    if (SHEditorUI::FUNC(Convert::ToNative(field->Name), val))                             \
+    if (SHEditorUI::FUNC(Convert::ToNative(field->Name), val, &isHovered))                 \
     {                                                                                      \
         field->SetValue(object, Convert::ToCLI(val));                                      \
         registerUndoAction(object, field, Convert::ToCLI(val), Convert::ToCLI(oldVal));    \
@@ -196,6 +197,8 @@ namespace SHADE
     }
     void Editor::renderFieldInInspector(Reflection::FieldInfo^ field, Object^ object)
     {
+        bool isHovered = false;
+
         if      RENDER_FIELD       (Int16,   int,             InputInt)
         else if RENDER_FIELD       (Int32,   int,             InputInt)
         else if RENDER_FIELD       (Int64,   int,             InputInt)
@@ -244,6 +247,15 @@ namespace SHADE
                 registerUndoAction(object, field, Convert::ToCLI(val), Convert::ToCLI(oldVal));
             }
         }
+
+        // Check if the field has a specific attribute
+        TooltipAttribute^ toolTip = hasAttribute<TooltipAttribute^>(field);
+        if (toolTip && isHovered)
+        {
+            SHEditorUI::BeginTooltip();
+            SHEditorUI::Text(Convert::ToNative(toolTip->Description));
+            SHEditorUI::EndTooltip();
+        }
     }
 
     void Editor::renderScriptContextMenu(Entity entity, Script^ script)
@@ -274,4 +286,24 @@ namespace SHADE
         SHCommandManager::RegisterCommand(std::reinterpret_pointer_cast<SHBaseCommand>(std::make_shared<SHCLICommand>()));
     }
 
+    generic<typename Attribute>
+    Attribute Editor::hasAttribute(System::Reflection::FieldInfo^ field)
+    {
+        array<System::Object^>^ attributes = field->GetCustomAttributes(true);
+        for each (System::Object^ attrib in attributes)
+        {
+            try
+            {
+                Attribute attribute = safe_cast<Attribute>(attrib);
+                if (attribute != nullptr)
+                    return attribute;
+            }
+            catch (System::InvalidCastException^)
+            {
+                continue;
+            }
+        }
+        // Failed to find
+        return Attribute{};
+    }
 }
diff --git a/SHADE_Managed/src/Editor/Editor.hxx b/SHADE_Managed/src/Editor/Editor.hxx
index c4800645..6b59589a 100644
--- a/SHADE_Managed/src/Editor/Editor.hxx
+++ b/SHADE_Managed/src/Editor/Editor.hxx
@@ -23,7 +23,7 @@ namespace SHADE
     /// <summary>
     /// Static class for Editor-related functions
     /// </summary>
-    public ref class Editor abstract sealed
+    private ref class Editor abstract sealed
     {
       public:
         /*-----------------------------------------------------------------------------*/
@@ -48,7 +48,13 @@ namespace SHADE
         /*-----------------------------------------------------------------------------*/
         /* UndoRedoStack Functions                                                     */
         /*-----------------------------------------------------------------------------*/
+        /// <summary>
+        /// Undoes the last script inspector change if there is any.
+        /// </summary>
         static void Undo();
+        /// <summary>
+        /// Redoes the last script inspector change if there is any.
+        /// </summary>
         static void Redo();
 
     private:
@@ -86,5 +92,7 @@ namespace SHADE
         /// <param name="script">The Script to render the inspector for.</param>
         static void renderScriptContextMenu(Entity entity, Script^ script);
         static void registerUndoAction(System::Object^ object, System::Reflection::FieldInfo^ field, System::Object^ newData, System::Object^ oldData);
+        generic<typename Attribute> where Attribute : System::Attribute
+        static Attribute hasAttribute(System::Reflection::FieldInfo^ field);
     };
 }
diff --git a/SHADE_Managed/src/Serialisation/SerialiseFieldAttribute.cxx b/SHADE_Managed/src/Editor/TooltipAttribute.cxx
similarity index 54%
rename from SHADE_Managed/src/Serialisation/SerialiseFieldAttribute.cxx
rename to SHADE_Managed/src/Editor/TooltipAttribute.cxx
index c371d200..8d5a5d55 100644
--- a/SHADE_Managed/src/Serialisation/SerialiseFieldAttribute.cxx
+++ b/SHADE_Managed/src/Editor/TooltipAttribute.cxx
@@ -1,27 +1,34 @@
 /************************************************************************************//*!
-\file           SerializeFieldAttribute.cxx
+\file           TooltipAttribute.cxx
 \author         Tng Kah Wei, kahwei.tng, 390009620
 \par            email: kahwei.tng\@digipen.edu
-\date           Nov 5, 2021
-\brief          Contains the definition of the functions of the managed SerializeField
-                Attribute class.
+\date           Oct 18, 2022
+\brief          Contains the definition of the functions of the managed Tooltip Attribute
+                class.
 
                 Note: This file is written in C++17/CLI.
- 
-Copyright (C) 2021 DigiPen Institute of Technology.
-Reproduction or disclosure of this file or its contents without the prior written consent 
+
+Copyright (C) 2022 DigiPen Institute of Technology.
+Reproduction or disclosure of this file or its contents without the prior written consent
 of DigiPen Institute of Technology is prohibited.
 *//*************************************************************************************/
-// Precompiled Headers
 #include "SHpch.h"
-// Primary Header
-#include "SerializeFieldAttribute.hxx"
+#include "TooltipAttribute.hxx"
 
 namespace SHADE
 {
+    /*---------------------------------------------------------------------------------*/
+    /* Properties                                                                      */
+    /*---------------------------------------------------------------------------------*/
+    System::String^ TooltipAttribute::Description::get()
+    {
+        return desc;
+    }
+
     /*---------------------------------------------------------------------------------*/
     /* Constructors                                                                    */
     /*---------------------------------------------------------------------------------*/
-    SerializeField::SerializeField()
+    TooltipAttribute::TooltipAttribute(System::String^ description)
+    : desc { description }
     {}
 }
diff --git a/SHADE_Managed/src/Editor/TooltipAttribute.hxx b/SHADE_Managed/src/Editor/TooltipAttribute.hxx
new file mode 100644
index 00000000..e7cd168c
--- /dev/null
+++ b/SHADE_Managed/src/Editor/TooltipAttribute.hxx
@@ -0,0 +1,53 @@
+/************************************************************************************//*!
+\file           TooltipAttribute.hxx
+\author         Tng Kah Wei, kahwei.tng, 390009620
+\par            email: kahwei.tng\@digipen.edu
+\date           Oct 18, 2022
+\brief          Contains the definition of the managed Tooltip Attribute class with
+                the declaration of functions for working with it.
+
+                Note: This file is written in C++17/CLI.
+
+Copyright (C) 2022 DigiPen Institute of Technology.
+Reproduction or disclosure of this file or its contents without the prior written consent
+of DigiPen Institute of Technology is prohibited.
+*//*************************************************************************************/
+#pragma once
+
+namespace SHADE
+{
+    /// <summary>
+    /// Simple attribute to mark that a field in a Script should be serialised.
+    /// </summary>
+    [System::AttributeUsage(System::AttributeTargets::Field)]
+    public ref class TooltipAttribute : public System::Attribute
+    {
+      public:
+        /*-----------------------------------------------------------------------------*/
+        /* Properties                                                                  */
+        /*-----------------------------------------------------------------------------*/
+        /// <summary>
+        /// Description that is to be shown in the Tooltip.
+        /// </summary>
+        property System::String^ Description
+        {
+            System::String^ get();
+        }
+
+        /*-----------------------------------------------------------------------------*/
+        /* Constructors                                                                */
+        /*-----------------------------------------------------------------------------*/
+        /// <summary>
+        /// Constructor for a Tooltip attribute that fills in the description.
+        /// </summary>
+        /// <param name="description">Text to be shown when a field is hovered.</param>
+        TooltipAttribute(System::String^ description);
+
+      private:
+        /*-----------------------------------------------------------------------------*/
+        /* Data Members                                                                */
+        /*-----------------------------------------------------------------------------*/
+        System::String^ desc;
+    };
+}
+
diff --git a/SHADE_Managed/src/Input/Input.cxx b/SHADE_Managed/src/Input/Input.cxx
new file mode 100644
index 00000000..0a386f3a
--- /dev/null
+++ b/SHADE_Managed/src/Input/Input.cxx
@@ -0,0 +1,102 @@
+/************************************************************************************//*!
+\file           Input.cxx
+\author         Tng Kah Wei, kahwei.tng, 390009620
+\par            email: kahwei.tng\@digipen.edu
+\date           Oct 16, 2022
+\brief          Contains the definition of the managed Input static class.
+
+                Note: This file is written in C++17/CLI.
+ 
+Copyright (C) 2022 DigiPen Institute of Technology.
+Reproduction or disclosure of this file or its contents without the prior written consent 
+of DigiPen Institute of Technology is prohibited.
+*//*************************************************************************************/
+#include "SHpch.h"
+#include "Input.hxx"
+#include "Utility/Convert.hxx"
+
+namespace SHADE
+{
+    /*---------------------------------------------------------------------------------*/
+    /* Properties                                                                      */
+    /*---------------------------------------------------------------------------------*/
+    Vector3 Input::MousePosition::get()
+    {
+        int x, y;
+        SHInputManager::GetMouseWindowPosition(&x, &y);
+        return Vector3(static_cast<float>(x), static_cast<float>(y), 0.0f);
+    }
+    int Input::MouseScrollDelta::get()
+    {
+        return SHInputManager::GetMouseWheelVerticalDelta();
+    }
+
+    /*---------------------------------------------------------------------------------*/
+    /* Usage Functions                                                                 */
+    /*---------------------------------------------------------------------------------*/
+    bool Input::GetKey(KeyCode key)
+    {
+        return SHInputManager::GetKey(static_cast<SHInputManager::SH_KEYCODE>(key));
+    }
+
+    bool Input::GetKeyDown(KeyCode key)
+    {
+        return SHInputManager::GetKeyDown(static_cast<SHInputManager::SH_KEYCODE>(key));
+    }
+
+    bool Input::GetKeyUp(KeyCode key)
+    {
+        return SHInputManager::GetKeyUp(static_cast<SHInputManager::SH_KEYCODE>(key));
+    }
+
+    bool Input::GetMouseButton(MouseCode mouseButton)
+    {
+        return SHInputManager::GetKey(static_cast<SHInputManager::SH_KEYCODE>(mouseButton));
+    }
+
+    bool Input::GetMouseButtonDown(MouseCode mouseButton)
+    {
+        return SHInputManager::GetKeyDown(static_cast<SHInputManager::SH_KEYCODE>(mouseButton));
+    }
+
+    bool Input::GetMouseButtonUp(MouseCode mouseButton)
+    {
+        return SHInputManager::GetKeyUp(static_cast<SHInputManager::SH_KEYCODE>(mouseButton));
+    }
+
+    /*---------------------------------------------------------------------------------*/
+    /* Cursor Functions                                                                */
+    /*---------------------------------------------------------------------------------*/
+    void Input::SetMousePosition(Vector2 pos)
+    {
+        SHInputManager::SetMouseWindowPosition
+        (
+            static_cast<int>(pos.x),
+            static_cast<int>(pos.y)
+        );
+    }
+
+    /*---------------------------------------------------------------------------------*/
+    /* Time Functions                                                                  */
+    /*---------------------------------------------------------------------------------*/
+    double Input::GetKeyHeldTime(KeyCode key)
+    {
+        return SHInputManager::GetKeyHeldTime(static_cast<SHInputManager::SH_KEYCODE>(key));
+    }
+
+    double Input::GetKeyReleasedTime(KeyCode key)
+    {
+        return SHInputManager::GetKeyReleasedTime(static_cast<SHInputManager::SH_KEYCODE>(key));
+    }
+
+    double Input::GetMouseHeldTime(MouseCode key)
+    {
+        return SHInputManager::GetKeyHeldTime(static_cast<SHInputManager::SH_KEYCODE>(key));
+    }
+
+    double Input::GetMouseReleasedTime(MouseCode key)
+    {
+        return SHInputManager::GetKeyReleasedTime(static_cast<SHInputManager::SH_KEYCODE>(key));
+    }
+
+}
\ No newline at end of file
